package jp.catsin.roboQCtrl_BT_Thread;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import backport.android.bluetooth.BluetoothAdapter;
import backport.android.bluetooth.BluetoothDevice;
import backport.android.bluetooth.BluetoothSocket;
import backport.android.bluetooth.protocols.BluetoothProtocols;

import android.os.Handler;
import android.util.Log;

public class BluetoothIF	{
	
	private Handler 			_handler 		= new Handler();
	private BluetoothAdapter	_bluetooth		= BluetoothAdapter.getDefaultAdapter();
	
	
    private BluetoothSocket 	socket 			= null;
    private Thread				recvThread		= null;
    private recvCallback		mRecvCallback	= null;
    
    public interface recvCallback {
        public void progressCallback(byte[] recvData);
    }
    
    protected void connect(final BluetoothDevice device) {
        Log.d("Bluetooth", "in CONNECT handler.");
        try {
            //----------------------------------------------
            //	MXbhi񓯊M̎j
            recvThread = new Thread(	new Runnable() {
           		public void run() {
           			try{
           				socket = device.createRfcommSocketToServiceRecord(BluetoothProtocols.RFCOMM_PROTOCOL_UUID, 1);
           				socket.connect();

           				final byte[] b = new byte[1024];
           				int readLen;

           				InputStream in = socket.getInputStream();
            				
               			while((readLen = in.read(b))>0){
							final int	len	= readLen;
							_handler.post( new Runnable() {
								public void run() {
									//	R[obNĂяo
									if( mRecvCallback!=null ){
										byte[]	recvData	= new byte[len];
										for( int i=0; i<len; i++ ){
											recvData[i] = b[i];
										}
										mRecvCallback.progressCallback(recvData);
									}
								}
							});
               			}
                    }catch(Exception e){
                    }finally{
       			}
           		}
           	});
            recvThread.start();
            //----------------------------------------------
		} catch (Exception e) {
			e.printStackTrace();
		}
    }
	protected void disconnect() {
        Log.d("Bluetooth", "in DISCONNECT handler.");
        
        //	\Pbg̒~
       	if(socket == null) {
        	return;
        }
        try {
        	socket.close();
        } catch (IOException e) {
        	e.printStackTrace();
        } finally {
        	socket = null;
        }
	}
	protected void send( byte[] sendData ) {
        Log.d("Bluetooth", "in SEND handler.");
    	if(socket == null) {
    		return;
    	}
        Log.d("Bluetooth", "send:" + new String(sendData));
		try {
			OutputStream out;
			out = socket.getOutputStream();
			out.write(sendData);
	        Log.d("Bluetooth", "get output.");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	public	boolean	isEnabled(){
		return( _bluetooth.isEnabled() );
	}
	public	void	setRecvCallback( recvCallback pRecvCallback ){
		mRecvCallback	= pRecvCallback;
	}
}
