package jp.catsin.roboQCtrl_BT_Thread;

import java.util.Timer;
import java.util.TimerTask;

import jp.catsin.roboQCtrl_BT_Thread.R;

import backport.android.bluetooth.BluetoothDevice;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.Button;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.SeekBar.OnSeekBarChangeListener;

public class RoboQCtrl_BT_Thread extends Activity {
	
    private static final int REQUEST_DISCOVERY = 0x1;

	private Handler 	_handler 		= new Handler();
    
    private TextView 	resultText		= null;
    private SeekBar		seekBar_Speed	= null;

	static	int			interval		= 500;
	static	byte		nBund			= 3;
	static	byte		nSpeed			= 3;

	private	BluetoothIF	myBluetoothIF	= null;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        myBluetoothIF	= new BluetoothIF();

        //	BTȂI
        if( myBluetoothIF==null ){
            Toast.makeText(this, "bluetoothIF create failed.", Toast.LENGTH_SHORT).show();
            finish();
            return;
        }
        
        if (!myBluetoothIF.isEnabled()) {
            Toast.makeText(this, "bluetooth disabled.", Toast.LENGTH_SHORT).show();
            finish();
            return;
        }
        
        setContentView(R.layout.main);

        resultText = (TextView) findViewById(R.id.TextView01);
        seekBar_Speed = (SeekBar) findViewById(R.id.SeekBar_Speed);
        seekBar_Speed.setMax(3);
        seekBar_Speed.setProgress(nSpeed);
        seekBar_Speed.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
            public void onProgressChanged(
                    SeekBar seekBar,
                    int progress,
                    boolean fromTouch) {
            	//	V[No[ł̑xwXV
            	nSpeed	= (byte) progress;
            }

			public void onStartTrackingTouch(SeekBar arg0) {
				// TODO Auto-generated method stub
				
			}

			public void onStopTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				
			}
        });
        
        //	M̃R[obN֐o^
        myBluetoothIF.setRecvCallback(
       		new BluetoothIF.recvCallback() {
       			public void progressCallback(byte[] recvData) {
                   	resultText.setText("read:" + new String(recvData));
                }
            }
        );
        
    	Timer t = new Timer();
		t.schedule( new TimerTask() {
			@Override
			public void run() {
				// \̍XV
				_handler.post( new Runnable() {
					public void run() {
						//	IɑM邽߁A^C}Ń{^Ԃǂݍނ悤ɂ
				        Button	button_Forward		=(Button)findViewById(R.id.Button_Forward);
				        Button	button_LeftTurn		=(Button)findViewById(R.id.Button_LeftTurn);
				        Button	button_RightTurn	=(Button)findViewById(R.id.Button_RightTurn);
						TextView	tv=(TextView)findViewById(R.id.TextView_Status);
						if( button_Forward.isPressed() ){
							tv.setText("Forward");

							byte	cmd	= (byte) ((nSpeed<<4)|(0x0<<2)|(nBund));
					        byte[] sendData = {cmd};
					        myBluetoothIF.send( sendData );
					        resultText.setText("send:" + new String(sendData));
						}
						if( button_LeftTurn.isPressed() ){
							tv.setText("LeftTurn");							

				        	byte	cmd	= (byte) ((nSpeed<<4)|(0x2<<2)|(nBund));
				        	byte[] sendData = {cmd};
				        	myBluetoothIF.send( sendData );
					        resultText.setText("send:" + new String(sendData));
						}						
						if( button_RightTurn.isPressed() ){
							tv.setText("RightTurn");							

							byte	cmd	= (byte) ((nSpeed<<4)|(0x1<<2)|(nBund));
							byte[] sendData = {cmd};
							myBluetoothIF.send( sendData );
					        resultText.setText("send:" + new String(sendData));
						}
						
					}
				});

			}

		}, interval, interval );
        
        //	BT`Jn
        Intent intent = new Intent(this, DiscoveryActivity.class);
        Toast.makeText(this, "select device to connect", Toast.LENGTH_SHORT)
                        .show();
        startActivityForResult(intent, REQUEST_DISCOVERY);        
    }

	//	BTʂ̃Ug
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode != REQUEST_DISCOVERY) {
            return;
        }

        if (resultCode != RESULT_OK) {
            Toast.makeText(this, "bluetooth disabled.", Toast.LENGTH_SHORT).show();
            finish();
            return;
        }

        final BluetoothDevice device = data.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);

        new Thread() {
            public void run() {
            	//	BTڑ
            	myBluetoothIF.connect(device);
            };
        }.start();
    }

    @Override
	protected void onStop() {
		super.onStop();
		//	BTؒf
		myBluetoothIF.disconnect();
	}

    //---------------------------------------------------------------
    // j[
    private static final int D_MENU_IDSELECT_ID			= 0;

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
    	boolean supRetVal = super.onCreateOptionsMenu(menu);
    	menu.add(0, D_MENU_IDSELECT_ID, 		0, "ID select"		);
       	return supRetVal;
    }
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case D_MENU_IDSELECT_ID:	//	I
            	//IXg
            	CharSequence[] items = new String[4];
            	for( int i=0; i<4; i++ ){
            		items[i]	= String.format("ID:%c",'A'+i);
            	}
            	AlertDialog.Builder builder = new AlertDialog.Builder(this);
            	builder.setTitle("ID Select");
            	builder.setSingleChoiceItems(items, nBund,
            		new DialogInterface.OnClickListener() {
            			public void onClick(DialogInterface dialog, int item) {
            				//	IeXV
            				nBund	= (byte) item;
            			}
            		});
            	AlertDialog mAlertDialog	= builder.create();
            	mAlertDialog.show();
            	items	= null;
            	return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }
}